import string
import sys
from os import environ

# Abstract class to wrap control and text retreival
class ControlWrapper:
	def __init__(self, data):
		self.label_string = ''
		self.name_string = ''
		self.default_string = ''
		self.main_widget = None
		self.pack_widget = None
		data_list = data.split(':', 2)
		self.num_entries = len(data_list)
		if self.num_entries == 3:
			self.label_string = data_list[0]
			self.name_string = data_list[1]
			self.default_string = data_list[2]
		elif self.num_entries == 2:
			self.label_string = data_list[0]
			self.default_string = data_list[1]
		else:
			self.default_string = data_list[0]
	def get_value(self):
		return ''
	def get_print_data(self):
		data = self.get_value()
		if self.name_string != '':
			return self.name_string + '=' + data
		else:
			return data

class ButtonWrapper:
	def __init__(self, btn_spec):
		self.btn_caption = ''
		self.exit_code = ''
		self.icon_name = ''	
		try:
			self.btn_caption, self.exit_code = string.split(btn_spec, ':')
		except:
			try:
				self.btn_caption, self.icon_name, self.exit_code = string.split(btn_spec, ':')
			except IndexError:
				raise
				#try:
				#	rox.alert("Unable to parse button definition!")
				#except:
				#	sys.stderr.write("Unable to parse button definition!")
				#sys.exit(exit_err)
	def set_default(self):
		pass
	def set_command(self, action):
		pass

# Abstract class for the application

class AppWin:
	def __init__(self):
		try:
			self.delimiter_string = environ['PYMESSAGE_DELIMITER']
		except:
			self.delimiter_strin = ':'
		self.print_flag=False
		self.control_list = []
		
	def exit_app(self, button, status):
		x = eval(status)
		output_str = ''
		for ctl in self.control_list:
			if output_str != '':
				output_str = output_str + self.delimiter_string + ctl.get_print_data()
			else:
				output_str = ctl.get_print_data()
		if self.print_flag:
			if output_str == '':
				output_str = status
			else:
				output_str = output_str + self.delimiter_string + status
		print output_str
		sys.exit(x)
		
#	def set_title(self):
#		pass
	def mainloop(self):
		pass
	def add_control(self, ctrl):
		pass
	def set_label_text(self, msg, use_markup = False):
		pass
	def add_button(self, btn):
		pass

# Abstract classes for alert and info boxes

class AlertWin:
	def __init__(self, msg):
		pass

class InfoWin:
	def __init__(self, msg):
		pass
